#include <GdiPlus.au3>
#include 'editor.au3'

Global $hTitel = "ObjT-IDE",$width = 700,$height = 600,$x = Default,$y = Default,$open_f = 0,$new_f = 0,$hSave = 0,$hOpen = 0

Projekt_Option()
Func Projekt_Option()
	$hGui = GUICreate("Options",120,160)
	GuiSetState()
	$open_f = 0
	$new_f = 0
	_GDIPlus_Startup()

	$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)

	$hBitmap = _GDIPlus_BitmapCreateFromGraphics(120,160,$hGraphic)
	$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

	$Open = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Unlocked2.png")
	$New = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Unlocked2.png")
	$Next = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Unlocked.png")

	While 1
		$msg = GUIGetMsg()
		$mouse = GUIGetCursorInfo($hGui)

		If IsArray($mouse) Then
			If $mouse[0] <= 120 and $mouse[1] <= 40 and $mouse[0] >= 0 and $mouse[1] >= 0 and $mouse[2] = 1 Then
				$Open = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\locked.png")
				$New = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Unlocked2.png")
				$open_f = 1
				$new_f = 0
			EndIf

			If $mouse[0] <= 120 and $mouse[1] <= 80 and $mouse[0] >= 0 and $mouse[1] >= 45 and $mouse[2] = 1 Then
				$Open = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Unlocked2.png")
				$New = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\locked.png")
				$open_f = 0
				$new_f = 1
			EndIf

			If $mouse[0] <= 120 and $mouse[1] <= 160 and $mouse[0] >= 0 and $mouse[1] >= 90 and $mouse[2] = 1 Then
				If $open_f = 1 and $new_f = 0 Then
					_OpenaObjTScript()
				ElseIf $open_f = 0 and $new_f = 1 Then
					_NewObjTScript()
				Else
					MsgBox(16,"Warning!","You have to click on sth. !")
				EndIf
			EndIf

		EndIf

		Switch $msg
			Case -3
				_GDIPlus_GraphicsDispose($hGraphic)
				_GDIPlus_GraphicsDispose($hBuffer)
				_GDIPlus_BitmapDispose($hBitmap)
				_GDIPlus_ImageDispose($Open)
				_GDIPlus_ImageDispose($New)
				_GDIPlus_ImageDispose($Next)
				_GDIPlus_Shutdown()
				Exit
		EndSwitch
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Open,0,0,120,40)
		_GDIPlus_GraphicsDrawString($hBuffer,"Open",45,15,"Arial",12)
		_GdiPlus_GraphicsDrawImageRect($hBuffer,$New,0,60,120,40)
		_GDIPlus_GraphicsDrawString($hBuffer,"New",45,75,"Arial",12)
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Next,0,120,120,40)
		_GDIPlus_GraphicsDrawString($hBuffer,"Next",45,135,"Arial",12)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, 120, 160)
	WEnd
EndFunc

Func Main()
	GUIDelete()
	$hGui = GUICreate($hTitel,$width,$height)
	_CreateEdit()
	GuiSetState()

	_GDIPlus_Startup()

	$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)

	$hBitmap = _GDIPlus_BitmapCreateFromGraphics($width,$height,$hGraphic)
	$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

	$Open = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Open.png")
	$New = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Neu.png")
	$Close = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Close.png")
	$Save = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Save.png")

	While 1
		$msg = GUIGetMsg()
		_Syntax_highlighting()
		$mouse = GUIGetCursorInfo($hGui)

		If IsArray($mouse) Then
			If $mouse[0] >= 0 and $mouse[1] >= 0 and $mouse[0] <= 40 and $mouse[1] <= 40 and $mouse[2] = 1 Then;New
				_NewCode()
			EndIf

			If $mouse[0] >= 45 and $mouse[1] >= 0 and $mouse[0] <= 90 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Open
				$hOpen = FileOpenDialog("Open a ObjT File",@ScriptDir,".objt Files(*.objt)")
				_OpenCode($hOpen)
			EndIf

			If $mouse[0] >= 90 and $mouse[1] >= 0 and $mouse[0] <= 135 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Close
				_GDIPlus_GraphicsDispose($hGraphic)
				_GDIPlus_GraphicsDispose($hBuffer)
				_GDIPlus_BitmapDispose($hBitmap)
				_GDIPlus_ImageDispose($Open)
				_GDIPlus_ImageDispose($New)
				_GDIPlus_ImageDispose($Close)
				_GDIPlus_ImageDispose($Save)
				_GDIPlus_Shutdown()
				Exit
			EndIf

			If $mouse[0] >= 135 and $mouse[1] >= 0 and $mouse[0] <= 180 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Save
				$hSave = FileSaveDialog("Save a ObjT File",@ScriptDir,".objt Files(*.objt)",16)

				if @error = 1 Then
				Else
					_SaveCode($hSave & ".objt")
				EndIf
			EndIf
		EndIf
		Switch $msg
			Case -3
				GUIDelete()
				_GDIPlus_GraphicsDispose($hGraphic)
				_GDIPlus_GraphicsDispose($hBuffer)
				_GDIPlus_BitmapDispose($hBitmap)
				_GDIPlus_ImageDispose($Open)
				_GDIPlus_ImageDispose($New)
				_GDIPlus_ImageDispose($Close)
				_GDIPlus_ImageDispose($Save)
				_GDIPlus_Shutdown()
				Projekt_Option()
		EndSwitch
		_GdiPlus_GraphicsDrawImageRect($hBuffer,$New,0,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Open,45,0,40,40)
		_GdiPlus_GraphicsDrawImageRect($hBuffer,$Close,90,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Save,135,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $width, $height)
	WEnd
EndFunc

Func _OpenaObjTScript()
	GUIDelete()
	$hOpen = FileOpenDialog("Open a ObjT File",@ScriptDir,".objt Files(*.objt)")
	$hGui = GUICreate($hOpen & " - " & "ObjT-IDE",$width,$height)
	_CreateEdit()
	_OpenCode($hOpen)
	GuiSetState()

	_GDIPlus_Startup()

	$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)

	$hBitmap = _GDIPlus_BitmapCreateFromGraphics($width,$height,$hGraphic)
	$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

	$Open = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Open.png")
	$New = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Neu.png")
	$Close = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Close.png")
	$Save = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Save.png")
	$Run = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Pics\Run_clicked.png")

	While 1
		$msg = GUIGetMsg()
		_Syntax_highlighting()
		$mouse = GUIGetCursorInfo($hGui)

		If IsArray($mouse) Then
			If $mouse[0] >= 0 and $mouse[1] >= 0 and $mouse[0] <= 40 and $mouse[1] <= 40 and $mouse[2] = 1 Then;New
				_NewCode()
			EndIf

			If $mouse[0] >= 45 and $mouse[1] >= 0 and $mouse[0] <= 90 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Open
				$hOpen = FileOpenDialog("Open a ObjT File",@ScriptDir,".objt Files(*.objt)")
				_OpenCode($hOpen)
			EndIf

			If $mouse[0] >= 90 and $mouse[1] >= 0 and $mouse[0] <= 135 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Close
				_GDIPlus_GraphicsDispose($hGraphic)
				_GDIPlus_GraphicsDispose($hBuffer)
				_GDIPlus_BitmapDispose($hBitmap)
				_GDIPlus_ImageDispose($Open)
				_GDIPlus_ImageDispose($New)
				_GDIPlus_ImageDispose($Close)
				_GDIPlus_ImageDispose($Save)
				_GDIPlus_Shutdown()
				Exit
			EndIf

			If $mouse[0] >= 135 and $mouse[1] >= 0 and $mouse[0] <= 180 and $mouse[1] <= 40 and $mouse[2] = 1 Then;Save
				$hSave = FileSaveDialog("Save a ObjT File",@ScriptDir,".objt Files(*.objt)",16)
				if @error = 1 Then
				Else
					_SaveCode($hSave & ".objt")
				EndIf
			EndIf
		EndIf
		Switch $msg
			Case -3
				GUIDelete()
				_GDIPlus_GraphicsDispose($hGraphic)
				_GDIPlus_GraphicsDispose($hBuffer)
				_GDIPlus_BitmapDispose($hBitmap)
				_GDIPlus_ImageDispose($Open)
				_GDIPlus_ImageDispose($New)
				_GDIPlus_ImageDispose($Close)
				_GDIPlus_ImageDispose($Save)
				_GDIPlus_Shutdown()
				Projekt_Option()
		EndSwitch
		_GdiPlus_GraphicsDrawImageRect($hBuffer,$New,0,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Open,45,0,40,40)
		_GdiPlus_GraphicsDrawImageRect($hBuffer,$Close,90,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hBuffer,$Save,135,0,40,40)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $width, $height)
	WEnd
EndFunc

Func _NewObjTScript()
	Main()
EndFunc